%if 0%{?fedora} > 39 || 0%{?rhel} > 7
%global websockets_support 1
%else
%global websockets_support 0
%endif

Name:     curl
Version:  8.13.0
Release:  1%{?dist}
Summary:  A utility for getting files from remote servers (FTP, HTTP, and others)
License:  curl
URL:      https://curl.se/
Packager: Teddysun <i@teddysun.com>
Source0:  https://curl.se/download/%{name}-%{version}.tar.xz
Source1:  https://curl.se/download/%{name}-%{version}.tar.xz.asc
Source2:  mykey.asc

Patch302: 0302-curl-7.74.0-pkgconfig.patch
Provides: curl-full = %{version}-%{release}
Provides: webclient

%if 0%{?rhel} > 7 && 0%{?rhel} < 10
BuildRequires: librtmp-devel
%endif
BuildRequires: brotli-devel
BuildRequires: libzstd-devel
BuildRequires: coreutils
BuildRequires: gcc
BuildRequires: krb5-devel
BuildRequires: libidn2-devel
BuildRequires: openldap-devel
BuildRequires: libgsasl-devel
BuildRequires: pkgconfig
BuildRequires: groff
BuildRequires: libnghttp2-devel >= 1.12.0
%if 0%{?fedora} > 33 || 0%{?rhel} > 8
BuildRequires: gnutls-devel >= 3.7.5
BuildRequires: libnghttp3-devel >= 1.0.0
BuildRequires: libngtcp2-devel >= 1.0.0
%endif
BuildRequires: libpsl-devel
BuildRequires: libssh2-devel >= 1.2
BuildRequires: make
BuildRequires: perl-interpreter
BuildRequires: sed
%if 0%{?el8}
BuildRequires: openssl3-devel >= 3.3.0
BuildRequires: libnghttp3-devel >= 1.0.0
%else
BuildRequires: openssl-devel
%endif
BuildRequires: zlib-devel
# Needed to compress content of tool_hugehelp.c after changing curl.1 man page
BuildRequires: perl(IO::Compress::Gzip)
# Needed for generation of shell completions
BuildRequires: perl(Getopt::Long)
BuildRequires: perl(Pod::Usage)
BuildRequires: perl(strict)
BuildRequires: perl(warnings)
# Using an older version of libcurl could result in CURLE_UNKNOWN_OPTION
Requires: libcurl%{?_isa} >= %{version}-%{release}
Requires: ca-certificates
# Test suite requirements
BuildRequires: gnutls-utils
BuildRequires: hostname
BuildRequires: openssh-clients
BuildRequires: openssh-server
BuildRequires: perl(B)
BuildRequires: perl(base)
BuildRequires: perl(constant)
BuildRequires: perl(Cwd)
BuildRequires: perl(Digest::MD5)
BuildRequires: perl(Digest::SHA)
BuildRequires: perl(Exporter)
BuildRequires: perl(File::Basename)
BuildRequires: perl(File::Copy)
BuildRequires: perl(File::Spec)
BuildRequires: perl(IPC::Open2)
BuildRequires: perl(List::Util)
BuildRequires: perl(Memoize)
BuildRequires: perl(MIME::Base64)
BuildRequires: perl(POSIX)
BuildRequires: perl(Storable)
BuildRequires: perl(Time::HiRes)
BuildRequires: perl(Time::Local)
BuildRequires: perl(vars)
BuildRequires: python3-devel

# stunnel is used by upstream tests but it does not seem to work reliably
# on s390x and occasionally breaks some tests (mainly 1561 and 1562)
%ifnarch s390x
BuildRequires: stunnel
%endif

# require at least the version of openssl-libs that we were built against,
# to ensure that we have the necessary symbols available (#1462184, #1462211)
%global openssl_version %({ pkg-config --modversion openssl 2>/dev/null || echo 0;} | sed 's|-|-0.|')

%description
curl is a command line tool for transferring data with URL syntax, supporting
FTP, FTPS, HTTP, HTTPS, SCP, SFTP, TFTP, TELNET, DICT, LDAP, LDAPS, FILE, IMAP,
SMTP, POP3 and RTSP.
curl supports SSL certificates, HTTP POST, HTTP PUT, FTP
uploading, HTTP form based upload, proxies, cookies, user+password
authentication (Basic, Digest, NTLM, Negotiate, kerberos...), file transfer
resume, proxy tunneling and a busload of other useful tricks.

%package -n libcurl
Summary: A library for getting files from web servers
Requires: libpsl%{?_isa} >= 0.20.2
Requires: libssh2%{?_isa} >= 1.2

%if 0%{?el8}
Requires: openssl3-libs%{?_isa} >= 1:3.3.0
%else
Requires: openssl-libs%{?_isa} >= 1:%{openssl_version}
%endif
Requires: libnghttp2%{?_isa} >= 1.33.0
%if 0%{?fedora} > 33 || 0%{?rhel} > 8
Requires: gnutls%{?_isa} >= 3.7.5
Requires: libnghttp3%{?_isa} >= 1.0.0
Requires: libngtcp2%{?_isa} >= 1.0.0
%endif
Provides: libcurl-full = %{version}-%{release}
Provides: libcurl-full%{?_isa} = %{version}-%{release}

%description -n libcurl
libcurl is a free and easy-to-use client-side URL transfer library, supporting
FTP, FTPS, HTTP, HTTPS, SCP, SFTP, TFTP, TELNET, DICT, LDAP, LDAPS, FILE, IMAP,
SMTP, POP3 and RTSP.
libcurl supports SSL certificates, HTTP POST, HTTP PUT,
FTP uploading, HTTP form based upload, proxies, cookies, user+password
authentication (Basic, Digest, NTLM, Negotiate, Kerberos4), file transfer
resume, HTTP proxy tunneling and more.

%package -n libcurl-devel
Requires: libcurl%{?_isa} = %{version}-%{release}
%if 0%{?el8}
Requires: openssl3-devel
%else
Requires: openssl-devel
%endif
Requires: libssh2-devel
Summary: Files needed for building applications with libcurl
Provides: curl-devel = %{version}-%{release}
Provides: curl-devel%{?_isa} = %{version}-%{release}
Obsoletes: curl-devel < %{version}-%{release}

%description -n libcurl-devel
The libcurl-devel package includes header files and libraries necessary for
developing programs that use the libcurl library. It contains the API
documentation of the library too.

%package -n curl-minimal
Summary: Conservatively configured build of curl for minimal installations
Provides: curl = %{version}-%{release}
Conflicts: curl

# Using an older version of libcurl could result in CURLE_UNKNOWN_OPTION
Requires: libcurl%{?_isa} >= %{version}-%{release}
# Needed for RemovePathPostfixes to work with shared libraries
%undefine __brp_ldconfig

%description -n curl-minimal
This is a replacement of the curl package for minimal installations. It
comes with a limited set of features compared to the curl package. On the
other hand, the package is smaller and requires fewer run-time dependencies to
be installed.

%package -n libcurl-minimal
Summary: Conservatively configured build of libcurl for minimal installations
Provides: libcurl = %{version}-%{release}
Provides: libcurl%{?_isa} = %{version}-%{release}
Conflicts: libcurl%{?_isa}

%if 0%{?el8}
Requires: openssl3-libs%{?_isa} >= 1:3.3.0
%else
Requires: openssl-libs%{?_isa} >= 1:%{openssl_version}
%endif
Requires: libnghttp2%{?_isa} >= 1.33.0
%if 0%{?fedora} > 33 || 0%{?rhel} > 8
Requires: gnutls%{?_isa} >= 3.7.5
Requires: libnghttp3%{?_isa} >= 1.0.0
Requires: libngtcp2%{?_isa} >= 1.0.0
%endif

%description -n libcurl-minimal
This is a replacement of the libcurl package for minimal installations. It
comes with a limited set of features compared to the libcurl package. On the
other hand, the package is smaller and requires fewer run-time dependencies to
be installed.

%prep
%{gpgverify} --keyring='%{SOURCE2}' --signature='%{SOURCE1}' --data='%{SOURCE0}'
%autosetup -p1

%build
%if 0%{?el8}
export LDFLAGS="$(pkg-config --libs-only-L openssl3)"
export CPPFLAGS="$(pkg-config --cflags openssl3)"
%else
export CPPFLAGS="$(pkg-config --cflags openssl)"
%endif
mkdir build-{full,minimal}
%global _configure ../configure
export common_configure_opts="        \
    --cache-file=../config.cache      \
    --disable-static                  \
    --enable-hsts                     \
    --enable-ipv6                     \
    --enable-symbol-hiding            \
    --enable-threaded-resolver        \
    --with-gssapi                     \
    --with-libidn2                    \
    --with-nghttp2                    \
%if 0%{?fedora} > 33 || 0%{?rhel} > 8
    --with-gnutls                     \
    --with-nghttp3                    \
    --with-ngtcp2                     \
%else
    --with-openssl                    \
%endif
%if 0%{?el8}
    --with-openssl-quic               \
    --with-nghttp3                    \
%endif
    --with-ca-bundle=%{_sysconfdir}/pki/ca-trust/extracted/pem/tls-ca-bundle.pem"

# configure minimal build
(
    cd build-minimal
    %configure $common_configure_opts \
    --disable-dict                    \
    --disable-gopher                  \
    --disable-imap                    \
    --disable-ldap                    \
    --disable-ldaps                   \
    --disable-docs                    \
    --disable-manual                  \
    --disable-mqtt                    \
    --disable-ntlm                    \
    --disable-pop3                    \
    --disable-rtsp                    \
    --disable-smb                     \
    --disable-smtp                    \
    --disable-telnet                  \
    --disable-tftp                    \
    --disable-tls-srp                 \
    --disable-websockets              \
    --without-brotli                  \
    --without-zstd                    \
    --without-librtmp                 \
    --without-libpsl                  \
    --without-libssh2
)

# configure full build
(
    cd build-full
    %configure $common_configure_opts \
    --enable-dict                     \
    --enable-gopher                   \
    --enable-imap                     \
    --enable-ldap                     \
    --enable-ldaps                    \
    --enable-docs                     \
    --enable-manual                   \
    --enable-mqtt                     \
    --enable-ntlm                     \
    --enable-pop3                     \
    --enable-rtsp                     \
    --enable-smb                      \
    --enable-smtp                     \
    --enable-telnet                   \
    --enable-tftp                     \
    --enable-tls-srp                  \
%if %{websockets_support}
    --enable-websockets               \
%endif
%if 0%{?fedora} > 28 || 0%{?rhel} > 7
    --with-brotli                     \
    --with-zstd                       \
%if 0%{?el10}
    --without-librtmp                 \
%else
    --with-librtmp                    \
%endif
%else
    --without-brotli                  \
    --without-zstd                    \
    --without-librtmp                 \
%endif
    --with-libpsl                     \
    --with-libssh2
)

# Remove bogus rpath
sed -i \
    -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' \
    -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' \
    build-{full,minimal}/libtool

%{make_build} -C build-minimal
%{make_build} -C build-full

%install
# Install and rename the library that will be packaged as libcurl-minimal
%{make_install} -C build-minimal/lib
rm -f %{buildroot}%{_libdir}/libcurl.{la,so}
for i in %{buildroot}%{_libdir}/*; do
    mv -v $i $i.minimal
done

# Install and rename the executable that will be packaged as curl-minimal
%{make_install} -C build-minimal/src
mv -v %{buildroot}%{_bindir}/curl{,.minimal}

# Install the executable and library that will be packaged as curl and libcurl
%{make_install} -C build-full

# Install zsh completion for curl
# (we have to override LD_LIBRARY_PATH because we eliminated rpath)
LD_LIBRARY_PATH="%{buildroot}%{_libdir}:$LD_LIBRARY_PATH" %{make_install} -C build-full/scripts

# --disable-static not always honoured
rm -f %{buildroot}%{_libdir}/libcurl.a %{buildroot}%{_libdir}/libcurl.la
install -d %{buildroot}%{_datadir}/aclocal
install -m 644 -p docs/libcurl/libcurl.m4 %{buildroot}%{_datadir}/aclocal

%ldconfig_scriptlets -n libcurl
%ldconfig_scriptlets -n libcurl-minimal

%files
%license COPYING
%doc CHANGES.md README RELEASE-NOTES
%doc docs/BUGS.md docs/DEPRECATE.md docs/FAQ docs/FEATURES.md
%doc docs/TODO docs/TheArtOfHttpScripting.md
%{_bindir}/curl
%{_mandir}/man1/*

%files -n libcurl
%license COPYING
%{_libdir}/libcurl.so.4
%{_libdir}/libcurl.so.4.[0-9].[0-9]

%files -n libcurl-devel
%doc docs/examples/*.c docs/examples/Makefile.example docs/INTERNALS.md
%doc docs/CONTRIBUTE.md docs/libcurl/ABI.md
%doc docs/GOVERNANCE.md
%{_bindir}/curl-config
%{_includedir}/curl/
%{_libdir}/*.so
%{_libdir}/pkgconfig/libcurl.pc
%{_mandir}/man1/*
%{_mandir}/man3/*
%{_datadir}/aclocal/libcurl.m4

%files -n curl-minimal
%{_bindir}/curl.minimal
%{_mandir}/man1/*

%files -n libcurl-minimal
%license COPYING
%{_libdir}/libcurl.so.4.minimal
%{_libdir}/libcurl.so.4.[0-9].[0-9].minimal

%changelog
* Mon Apr 07 2025 Teddysun <i@teddysun.com> - 8.13.0-1
- Update version to 8.13.0

* Thu Feb 13 2025 Teddysun <i@teddysun.com> - 8.12.1-1
- Update version to 8.12.1

* Wed Feb 05 2025 Teddysun <i@teddysun.com> - 8.12.0-1
- Update version to 8.12.0

* Wed Dec 18 2024 Teddysun <i@teddysun.com> - 8.11.1-3
- Fix crash with Unexpected error 9 on netlink descriptor 10 (rhbz#2332350)

* Wed Dec 18 2024 Teddysun <i@teddysun.com> - 8.11.1-2
- Use tls-ca-bundle.pem instead of ca-bundle.crt (RHEL-56966)

* Wed Dec 11 2024 Teddysun <i@teddysun.com> - 8.11.1-1
- Update version to 8.11.1

* Mon Nov 25 2024 Teddysun <i@teddysun.com> - 8.11.0-2
- Fixed requires pkgconfig(ldap) when rhel = 8

* Wed Nov 06 2024 Teddysun <i@teddysun.com> - 8.11.0-1
- Update version to 8.11.0

* Wed Sep 18 2024 Teddysun <i@teddysun.com> - 8.10.1-1
- Update version to 8.10.1

* Sun Sep 15 2024 Teddysun <i@teddysun.com> - 8.10.0-2
- Clean spec file
- Fixed requires software version

* Wed Sep 11 2024 Teddysun <i@teddysun.com> - 8.10.0-1
- Update version to 8.10.0
- Option --enable-websockets if fedora > 39 or rhel > 7

* Tue Sep 10 2024 Teddysun <i@teddysun.com> - 8.9.1-4
- Support protocol rtmp when rhel > 7
- Build with librtmp when rhel > 7

* Tue Sep 10 2024 Teddysun <i@teddysun.com> - 8.9.1-3
- Build with libssh2 by default

* Thu Aug 01 2024 Teddysun <i@teddysun.com> - 8.9.1-2
- Support feature gsasl
- Support feature zstd
- HTTP3 enabled (openssl3 + nghttp3) when rhel == 8
- Build with openssl3 when rhel == 8

* Thu Aug 01 2024 Teddysun <i@teddysun.com> - 8.9.1-1
- Update version to 8.9.1

* Wed May 22 2024 Teddysun <i@teddysun.com> - 8.8.0-1
- Update version to 8.8.0

* Wed Mar 27 2024 Teddysun <i@teddysun.com> - 8.7.0-1
- Update version to 8.7.0

* Wed Jan 31 2024 Teddysun <i@teddysun.com> - 8.6.0-1
- Update version to 8.6.0

* Wed Dec 06 2023 Teddysun <i@teddysun.com> - 8.5.0-1
- Update version to 8.5.0

* Mon Oct 23 2023 Teddysun <i@teddysun.com> - 8.4.0-2
- HTTP3 enabled (ngtcp2 + nghttp3) if fedora > 33 or rhel > 8
- Option --with-gnutls replaced --with-openssl if fedora > 33 or rhel > 8

* Wed Oct 11 2023 Teddysun <i@teddysun.com> - 8.4.0-1
- Update version to 8.4.0
